//+------------------------------------------------------------------+
//|                             normalized deviations oscillator.mq4 |
//|                25 August 2011                             mladen |
//|                                                                  |
//| original developed by William Cringan (TASC 2/2003)              |
//+------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_color2     Yellow
#property indicator_width2     2
#property indicator_color3     Red
#property indicator_width3     2
#property indicator_minimum    -5
#property indicator_maximum    105
#property indicator_level1     25
#property indicator_level2     50
#property indicator_level3     75
#property indicator_levelcolor DarkKhaki

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    NdoPrice     = PRICE_CLOSE;
extern int    EMAPeriod    = 15;
extern int    AtrPeriod    = 12;
extern int    SigMaPeriod  = 3;
extern int    Ma_Mode      = MODE_SMMA;
extern int    NormPeriod   = 100;
extern int    SmoothLength = 5;
extern double SmoothPhase  = 0;
extern bool   SmoothDouble = true;
extern bool   Interpolate  = true;

//
//
//
//
//

double ndo[];
double natr[];
double ndma[];
double dos[];
double atr[];
double temp[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//-----------------------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,ndo);
   SetIndexBuffer(1,natr);
   SetIndexBuffer(2,ndma);
   SetIndexBuffer(3,dos);
   SetIndexBuffer(4,atr);
   SetIndexBuffer(5,temp);
   SetIndexBuffer(6,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" noda");
 return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+-----------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,k,n,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
          int limit = MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { ndo[0] = MathMin(limit+1,Bars-1); return(0); }
    
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for (i=limit; i>=0; i--) temp[i] = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
      for (i=limit; i>=0; i--)
      {
         atr[i] = iMAOnArray(temp,Bars,AtrPeriod,0,Ma_Mode,i);
         dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
         //
         //
         //
         //
         //
         
            double hi     = dos[ArrayMaximum(dos,NormPeriod,i)];
            double lo     = dos[ArrayMinimum(dos,NormPeriod,i)];
            double MaxAtr = atr[ArrayMaximum(atr,NormPeriod,i)];
            double MinAtr = atr[ArrayMinimum(atr,NormPeriod,i)];
         
            if (hi!=lo)
                 ndo[i] = iDSmooth(100*(dos[i]- lo)/(hi - lo),SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
            else ndo[i] = iDSmooth(                         0,SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
            if (MaxAtr!=MinAtr)
                 natr[i] = iDSmooth(100*(atr[i]-MinAtr)/(MaxAtr-MinAtr),SmoothLength,SmoothPhase,SmoothDouble,i,20);
            else natr[i] = iDSmooth(                                  0,SmoothLength,SmoothPhase,SmoothDouble,i,20);
      }
      for (i=limit; i>=0; i--)
      {
         ndma[i] = iMAOnArray(ndo,Bars,SigMaPeriod,0,Ma_Mode,i);             
         trend[i]= trend[i+1];
                          
           if (ndo[i] > ndma[i] && ndo[i] > natr[i] && ndma[i] > natr[i]) trend[i] =  1;
           if (ndo[i] < ndma[i] && ndo[i] < natr[i] && ndma[i] < natr[i]) trend[i] = -1;
      }
      return (0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,7,y);
         ndo[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,0,y);
         natr[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,1,y);
         ndma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,2,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  ndo[i+k]  = ndo[i]  + (ndo[i+n]  - ndo[i] )*k/n;
                  natr[i+k] = natr[i] + (natr[i+n] - natr[i])*k/n;
                  ndma[i+k] = ndma[i] + (ndma[i+n] - ndma[i])*k/n;
               }
   }
   return(0);         
}
          
//-----------------------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//-----------------------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}